// Cube-Dijkstra-8x8-FB

#include <iostream>
#include <string>
#include <stack>
using namespace std;

int side[6];
int board[8][8];

struct pos
{ int front,back,top,right,down,left;

  pos()
  { front = back = left = right = top = down = 0; }

  pos(int f,int b,int t,int r,int d,int l)
  { front = f; back = b; 
    left = l; right = r;
    top = t; down = d;
  }
  
  pos move(int dir)
  { if(dir==0) return pos(down,top,front,right,back,left); // north
    if(dir==1) return pos(front,back,left,top,right,down); // east 
    if(dir==2) return pos(top,down,back,right,front,left); // south     
    return            pos(front,back,right,down,left,top); // west  
  }   
  
  bool operator==(const pos & p)
  { return front==p.front && left==p.left; }        
  
};

pos p[24];
int t[24][4];
int m;

int explore(pos q)
{ int k=0;
  while(k<m && !(q == p[k])) k++;
  if(k==m)  
  { p[k]=q; m++; 
    for(int i=0; i<4; i++)
      t[k][i] = explore(q.move(i));  
  }    
  return k;  
}    
  
struct vertex 
{ int x, y, p; 
  vertex() { x = y = p = 0; }
  vertex(int _x, int _y, int _p) 
  { x = _x; y = _y; p = _p; }
};

vertex a[1536];
int n;

int d[8][8][24];
int s[8][8][24];
vertex pr[8][8][24];

void dijkstra(int x1, int y1)
{ const int inf = 1000000;
  const int dx[4] = {0, 1,  0, -1 };
  const int dy[4] = {1, 0, -1,  0 };

  int n=0;
  for(int x=0; x<8; x++)
    for(int y=0; y<8; y++)
      if(board[x][y]==0)
      for(int p=0; p<24; p++)
      { a[n].x=x; a[n].y=y; a[n].p=p; n++;
        d[x][y][p] = inf;
        s[x][y][p] = inf;
      }

  d[x1][y1][0]=0;       
  s[x1][y1][0]=side[p[0].down];  
  
  while(n>1)
  { int k=-1, dmin=inf, smin=inf;
    for(int i=0; i<n; i++)
    { int x=a[i].x, y=a[i].y, p=a[i].p;
      if(dmin > d[x][y][p] || 
         (dmin == d[x][y][p] && smin > s[x][y][p]))
      { dmin = d[x][y][p]; smin = s[x][y][p];
        k = i;
      }
    } 
         
    if(k==-1) return;
    
    vertex u = a[k];
    a[k] = a[n-1];
    n--;
                  
    for(int j=0; j<4; j++)
    { vertex v;
      v.x = u.x + dx[j]; v.y = u.y + dy[j]; v.p=t[u.p][j];
      if(0<=v.x && v.x<=7 && 0<=v.y && v.y<=7 && board[v.x][v.y]==0)
      {
        if( d[u.x][u.y][u.p]+1 < d[v.x][v.y][v.p] ||
            ( d[u.x][u.y][u.p]+1 == d[v.x][v.y][v.p] && 
              s[u.x][u.y][u.p]+side[p[v.p].down] < s[v.x][v.y][v.p]
            )
          ) 
          { d[v.x][v.y][v.p] = d[u.x][u.y][u.p] + 1;
            s[v.x][v.y][v.p] = s[u.x][u.y][u.p]+side[p[v.p].down];
            pr[v.x][v.y][v.p] = vertex(u.x,u.y,u.p);
          }
      }
    }    
  }
}       
  

int main()
{ int x1,y1,x2,y2;
  string s1,s2;
  cin >> s1 >> s2;
  x1=s1[0]-'a'; y1=s1[1]-'1';
  x2=s2[0]-'a'; y2=s2[1]-'1';

  for(int i=0; i<6; i++)
    cin >> side[i];
   
  int fig;  
  cin >> fig;
  for(int i=0; i<fig; i++)
  { string s; cin >> s;
    int x = s[0]-'a', y=s[1]-'1';
    board[x][y] = 1;
  }   
           
  explore(pos(0,1,2,3,4,5));
  dijkstra(x1,y1);
  
  int dmin = d[x2][y2][0];
  int smin = s[x2][y2][0];
  int k = 0;
  for(int i=1; i<24; i++)
    if(dmin > d[x2][y2][i] || 
        (dmin == d[x2][y2][i] && smin > s[x2][y2][i])
      )
      { dmin = d[x2][y2][i];
        smin = s[x2][y2][i];
        k = i;
      }
  
  cout << smin << endl;

/*
  cout << "moves: " << dmin << "  sum: " << smin << endl;

  stack<vertex> path;
  vertex u(x2,y2,k);
  path.push(u);
  for(int i=dmin; i>0; i--)
  { u = pr[u.x][u.y][u.p];
    path.push(u);
  }  
  
  while(! path.empty())
  { vertex u = path.top(); 
    path.pop();
    cout << char('a'+u.x) << char('1'+u.y) << " " << side[p[u.p].down] << endl;
  }
*/
    
  return 0;
}
      
